#include "neural.h"
# include <math.h>
neural::neural()
{
    learningRate=0.01;
    nweight=1;
    maxepochs=500;
}
void    neural::setTrainSet(Dataset *t)
{
    trainSet=t;
    //arxikopoihhsh baron
    weight.resize((trainSet->getdimension()+2)*nweight);
    int i;
    for(i=0;i<weight.size();i++)
    {
        weight[i]=2 * (rand() *1.0/RAND_MAX-1.0);
    }
    //eyresi monadikon katigorion
    for(i=0;i<trainSet->getpatterns();i++)
    {
        double y=trainSet->gety(i);
        if(classVector.indexOf(y)==-1)  classVector<<y;
    }
}

void    neural::setTestSet(Dataset *t)
{
    testSet=t;
}

double  neural::getLearningRate()
{
    return learningRate;
}

void    neural::setLearningRate(double x)
{
    if(x>0 && x<1)
        learningRate=x;
}

int     neural::getMaxEpochs()
{
    return maxepochs;
}

void    neural::setMaxEpochs(int m)
{
    if(m>0)
        maxepochs=m;
}

void    neural::setWeights(Data w)
{
    weight=w;
}

Data    neural::getWeights()
{
    return weight;
}

void    neural::setNWeights(int N)
{
    //arxikopoihhsh baron
    nweight=N;
    weight.resize((trainSet->getdimension()+2)*nweight);
    int i;
    for(i=0;i<weight.size();i++)
    {
        weight[i]=2* (rand() *1.0/RAND_MAX-1);
    }
}

double  neural::sig(double x)
{
    return 1.0/(1.0+exp(-x));
}

double  neural::sigder(double x)
{
    double s=sig(x);
    return s*(1.0-s);
}

double  neural::getOuput(Data pattern)
{
    //exodos tou diktyou
    int d=trainSet->getdimension();
    int nodes=weight.size()/(d+2);//komboi epeksergasias
    int i,j;
    double sum=0.0;
    for(i=1;i<=nodes;i++)
    {
        double arg=0.0;
        for(j=1;j<=d;j++)
        {
            int posj=(d+2)*i-(d+1)+j;
            arg+=weight[posj-1]*pattern[j-1];
        }
        int posbias=(d+2)*i;//polosi
        arg+=weight[posbias-1];
        int pos=(d+2)*i-(d+1);
        sum+=weight[pos-1]*sig(arg);
    }
    return sum;
}

double  neural::getClass(Data pattern)
{
    //euresi kontinoteris katigorias
    double f=getOuput(pattern);
    int minClass=0;
    double minDist=fabs(classVector[0]-f);
    int i;
    for(i=0;i<classVector.size();i++)
    {
        double dist=fabs(classVector[i]-f);
        if(dist<minDist)
        {
            minClass=i;
            minDist=dist;
        }
    }
    return classVector[minClass];
}

double  neural::getTrainError()
{
    //sfalma ekpaideysis
    double sum=0.0;
    int i;
    for(i=0;i<trainSet->getpatterns();i++)
    {
        double ox=getOuput(trainSet->getpoint(i));
        double yx=trainSet->gety(i);
        sum+=(ox-yx)*(ox-yx);
    }
    return sum;
}

double  neural::getTestError()
{
    //sfalma elegxou
    double sum=0.0;
    int i;
    for(i=0;i<testSet->getpatterns();i++)
    {
        double ox=getOuput(testSet->getpoint(i));
        double yx=testSet->gety(i);
        sum+=(ox-yx)*(ox-yx);
    }
    return sum;
}

double  neural::getClassError()
{
    //sfalma katigoriopoihshs
    int missed=0;
    int i;
    for(i=0;i<testSet->getpatterns();i++)
    {
        Data pattern=testSet->getpoint(i);
        double d=getClass(pattern);
        double y=testSet->gety(i);
        if(fabs(d-y)>1e-5) missed++;
    }
    return missed * 100.0/testSet->getpatterns();
}

Data    neural::getDerivAtPoint(Data xpoint)
{
    //paragogos ana simeio
    Data g;
    g.resize(weight.size());
    int d=trainSet->getdimension();
    int nodes=weight.size()/ (d + 2);
    for(int i=1;i<=nodes;i++)
    {
        double arg=0.0;
        for(int j=1;j<=d;j++)
        {
            int pos=(d+2)*i-(d+1)+j;
            arg+=xpoint[j-1]*weight[pos-1];
        }
        arg+=weight[(d+2)*i-1];
        double s=sig(arg);
        double s2=sigder(arg);
        g[(d+2)*i-(d+1)-1]=s;
        g[(d+2)*i-1]=weight[(d+2)*i-(d+1)-1]*s2;
        for(int j=1;j<=d;j++)
        {
            int pos=(d+2)*i-(d+1)+j;
            g[pos-1]=weight[(d+2)*i-(d+1)-1]*xpoint[j-1]*s2;
        }
    }

    return g;
}

Data    neural::getDeriv()
{
    //parogogos
    Data g;
    g.resize(weight.size());
    int i,j;
    for(i=0;i<g.size();i++)
        g[i]=0.0;

    for(i=0;i<trainSet->getpatterns();i++)
    {
        Data x=trainSet->getpoint(i);
        Data gx=getDerivAtPoint(x);
        double ox=getOuput(x);
        double yx=trainSet->gety(i);
        for(j=0;j<g.size();j++)
            g[j]+=2.0*(ox-yx)*gx[j];
    }
    return g;
}

void    neural::train()
{
    //ekpaideysi
    int k,i;
    Data g;
    for(k=1;k<=maxepochs;k++)
    {
        double E=getTrainError();
        if(E<1e-5) break;
        g=getDeriv();
        for(i=0;i<weight.size();i++)
        {
            //enimerosi baron apo to sfalma
            weight[i]=weight[i]-learningRate*g[i];
        }
        printf("Iteration: %d Error: %lf\n",k,E);
    }
}
